// VARIABLES  ===============================================================================

const URL_CHECK_ID = 'upload.php';
const URL_DETOURAGE = "removeBackground2.php";

const ID = "img-ID";
const canva = "canvas";

const idConsole = "div";var Console;

const idFileUpload = "fileUpload"; var inputFileUpload;
const idCustomFileUpload = "custom-fileUpload"; var btnCustomFileUpload;
const idBtnSubmit = 'btnSubmit';var btnSubmit;

const idStatut = "span-status";

var errorUpload = true;
var errorRemoveBackGround = true;


// SCRIPT ====================================================================================

$(document).ready(function(){

  inputFileUpload = $("#"+idFileUpload);
  console.log(inputFileUpload.val());
  btnCustomFileUpload = $("#"+idCustomFileUpload);
  btnSubmit = $("#"+idBtnSubmit);
  Console = $("#"+idConsole);

  

    $("#form").on("submit",function (event) {
        event.preventDefault();
        var formData = new FormData(this);
        console.log(inputFileUpload.attr('filename'));
        $.ajax({
            //url de la requête
            url: URL_CHECK_ID,
            method: 'POST',
            enctype: 'multipart/form-data',
            data: formData,
            cache: false,

            dataType: "json",
            contentType: false,
            processData: false
        })
        .done(function(data){
          console.log(data);
          src = data['src'];
          console.log('src');
          errorUpload = data['error'];
          Console.empty();
          Console.append(data['message']);

          //Affichage de la photo
          $("#img-ID").attr('src',data['src']);
          findFaces();
        })
        .fail(function(error){
          Console.empty();
          alert("La requête s'est terminée en échec. Infos : " + JSON.stringify(error));
        })


        $.ajax({
          //url de la requête
          url: URL_DETOURAGE,
          
          method: 'POST',
          enctype: 'multipart/form-data',
          data: formData,
          cache: false,

          dataType: "json",
          contentType: false,
          processData: false
      })
      .done(function(data){
        console.log(data);

        //Affichage de la photo
        $("#img-ID2").attr('src',data['src']);
      })
      // $("#img-ID2").attr('src','img_bg\\pierremarqueno-bg.png')
    });

    
});

// FONCTIONS  ================================================================================

async function findFaces() {
  btnCustomFileUpload.prop('disabled',true);
  btnSubmit.prop('disabled',true);
  console.log('_findFaces()');
  const model = await blazeface.load();  
  // const img = ID;
  const img = document.getElementById(ID);
  const predictions = await model.estimateFaces(img, false);
  console.log('_findFaces()');
  if (predictions.length > 0) {
      console.log("faces found");
      console.log(predictions.length);
      $("#"+idStatut).empty();
      $("#"+idStatut).append(predictions.length+" face(s) found!");
      // const canvas =  document.getElementById(canva);
      // canvas.width = img.width;
      // canvas.height = img.height;
      // const ctx = canvas.getContext("2d");
      // ctx.fillStyle = "rgba(250,225,6,0.5)";
      // for (let i = 0; i < predictions.length; i++) 
      // {
      //   const start = predictions[i].topLeft;
      //   const end = predictions[i].bottomRight;
      //   const size = [end[0] - start[0], end[1] - start[1]];
      //   ctx.fillRect(start[0], start[1], size[0], size[1]);
      //   var landmark;
      //   for (let j = 0; j < predictions[i].landmarks.length; j++)
      //   {
      //     landmark = predictions[i].landmarks[j];
      //     ctx.beginPath();
      //     ctx.arc(landmark[0],landmark[1], 1, 0, 2*Math.PI,false);
      //     ctx.fill();
      //     ctx.lineWidth = 1;
      //     ctx.strokeStyle = '#ff0000';
      //     ctx.stroke();
      //   }
      // }
  } 
  else {
    $("#"+idStatut).append("No Face(s) Found");
  }
  btnSubmit.prop('disabled',false);
  btnCustomFileUpload.prop('disabled',false);
}


function getFile(filePath) {
  return filePath.substr(filePath.lastIndexOf('\\') + 1) ;
}


